"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const listener = __importStar(require("./../wsListener"));
const mock_socket_1 = require("mock-socket");
xtest('ws connect', () => __awaiter(void 0, void 0, void 0, function* () {
    const fakeURL = 'wss://ordering.3e.pl';
    const mockServer = new mock_socket_1.Server(fakeURL + '/websocket');
    mockServer.on('connection', (socket) => {
        socket.on('message', (data) => {
            console.log(data);
            socket.send('test message from mock server');
        });
    });
    const refreshTokenHandler = {
        getRefreshToken: (tenant) => {
            return 'refresh_token';
        },
        setRefreshToken: (tenant, r) => { },
        clearRefreshToken: (tenant) => { },
    };
    const ctx = {
        TENANT: 'aaa',
        VENUE: 'bbb',
        BASE_URL: fakeURL,
    };
    const params = {
        baseURL: process.env.BASE_URL || '',
        tenant: ctx.TENANT,
        venue: ctx.VENUE,
        authDataProvider: authDataProvider,
        //refreshTokenHandler,
        onConnectedAsync: (accessToken) => __awaiter(void 0, void 0, void 0, function* () {
            console.log('ws connected!');
        }),
        onDisconnectAsync: () => __awaiter(void 0, void 0, void 0, function* () {
            console.log('ws disconnected');
            //webSocketConnected = false;
        }),
        onKDSMessageAsync: (message) => __awaiter(void 0, void 0, void 0, function* () {
            // we have new message
            console.log(`new or updated order [${message.id}]`);
        }),
        onOrdersUpdateAsync: (order) => __awaiter(void 0, void 0, void 0, function* () { }),
        onNotificationAsync: (message) => __awaiter(void 0, void 0, void 0, function* () {
            console.log(`NOTIFICATION: ${JSON.stringify(message)}`);
        }),
        onAuthFailure: () => __awaiter(void 0, void 0, void 0, function* () { }),
        enableKDS: true,
    };
    yield listener.connectWebSockets(params);
}));
const authDataProvider = (
// ctx: any,
// refreshTokenProvider,
// forceRefresh?: boolean,
) => __awaiter(void 0, void 0, void 0, function* () {
    return { token: 'aaa', UUID: 'user1' };
});
function initWSForTest(baseURL) {
    return __awaiter(this, void 0, void 0, function* () {
        // listener is responsible for receiving orders from Ordering Stack
    });
}
