import { EOrderLineStatus, IOrder } from './orderTypes';
/**
 Pulls open orders for venue. Uses provided access token to authenticate to rest api.
 * @param baseURL
 * @param {*} venue - we pull orders for this venue
 * @param {*} token - access token
 */
export declare function pullOrders(baseURL: string, venue: string, token: string): Promise<IOrder[]>;
/**
 Pulls open orders for the user. Uses provided access token to authenticate to rest api.
 * @param baseURL
 * @param {*} token - access token
 * @param onlyCompletedOrders - option to pull also not yet completed orders
 */
export declare function pullOrdersForUser(baseURL: string, token: string, onlyCompletedOrders?: boolean): Promise<IOrder[]>;
export declare function updateCentrallyOrderExtraAttr(baseURL: string, token: string, orderId: string, store: string): Promise<boolean>;
export declare function postNewOrder(baseURL: string, token: string, order: IOrder): Promise<any>;
export declare function createOrderPayment(baseURL: string, token: string, orderId: string, paymentType: number, amount: number, returnUrl: string, returnErrorUrl: string, source: string): Promise<any>;
export declare function addOrderContactData(baseURL: string, token: string, orderId: string, name?: string, phone?: string, email?: string): Promise<any>;
export declare function appendOrderLine(baseURL: string, token: string, orderId: string, venueId: string, productId: string, price: number, quantity: number, status?: EOrderLineStatus, productConfig?: any, comment?: string, extra?: any): Promise<any>;
