import { IAuthDataProvider, IOrder, IOrderRec, IOrderServerTool } from './orderTypes';
import { ApplicationInsights } from '@microsoft/applicationinsights-web';
export interface OrderRecHashmap {
    [id: string]: IOrderRec;
}
export declare const setOrderStoreUpdatedCallback: (_callback: (rec: IOrderRec | undefined, orders: OrderRecHashmap) => void) => void;
export declare const cmdOrderCreate: (ctx: any, authDataProvider: IAuthDataProvider, orderServerTool: IOrderServerTool) => Promise<{
    id: string;
    correlationId: string;
}>;
export declare const onUpdateAllOrders: (orders: IOrder[], isKDS: boolean, venueId: string, appInsights?: ApplicationInsights) => void;
export declare const onOrderUpdate: (orderData: IOrder, isKDS: boolean, venueId: string) => void;
export declare const onOrderError: (errorMsg: any) => void;
export declare const getOrderStore: () => OrderRecHashmap;
export declare const clearOrderStore: () => void;
