"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mutex = void 0;
class Mutex {
    constructor(interval = 0) {
        this.locked = false;
        this._interval = 0;
        this.locked = false;
        this._interval = interval;
    }
    static _lock(mutex) {
        if (mutex.locked) {
            // is already locked, can't execute
            return false;
        }
        mutex.locked = true;
        // was not already locked, can execute
        return true;
    }
    static _unlock(mutex) {
        if (!mutex.locked) {
            return false;
        }
        mutex.locked = false;
        return true;
    }
    getLock(func) {
        const self = this;
        return new Promise(function executor(resolve, reject) {
            if (!Mutex._lock(self)) {
                // was already locked, try again at given interval
                setTimeout(() => {
                    executor(resolve, reject);
                }, self._interval);
                return;
            }
            // try getting promise
            let prom;
            try {
                prom = func();
            }
            catch (e) {
                reject(e);
                Mutex._unlock(self);
                return;
            }
            Promise.resolve(prom)
                .then((res) => {
                resolve(res);
                Mutex._unlock(self);
            })
                .catch((err) => {
                reject(err);
                Mutex._unlock(self);
            });
        });
    }
}
exports.Mutex = Mutex;
