import { IConfiguredAuthDataProvider } from './orderTypes';
import { ApplicationInsights } from '@microsoft/applicationinsights-web';
export interface ConnectWebSocketsParams {
    baseURL: string;
    tenant: string;
    venue: string;
    authDataProvider: IConfiguredAuthDataProvider;
    onConnectedAsync: any;
    onDisconnectAsync: any;
    onKDSMessageAsync: any;
    onOrdersUpdateAsync: any;
    onNotificationAsync: any;
    onSteeringCommand?: (message: any) => void;
    onAuthFailure: any;
    enableKDS: boolean;
    extra?: {
        appInsights?: ApplicationInsights;
        debugWs?: boolean;
    };
}
/**
 * Create Stomp on websocket connection to Ordering Stack listening for new orders to process by handlers/callback (onMessageAsync)
 */
export declare function connectWebSockets(params: ConnectWebSocketsParams): Promise<() => Promise<void>>;
