var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as listener from './../wsListener';
import { Server } from 'mock-socket';
xtest('ws connect', () => __awaiter(void 0, void 0, void 0, function* () {
    const fakeURL = 'wss://ordering.3e.pl';
    const mockServer = new Server(fakeURL + '/websocket');
    mockServer.on('connection', (socket) => {
        socket.on('message', (data) => {
            console.log(data);
            socket.send('test message from mock server');
        });
    });
    const refreshTokenHandler = {
        getRefreshToken: (tenant) => {
            return 'refresh_token';
        },
        setRefreshToken: (tenant, r) => { },
        clearRefreshToken: (tenant) => { },
    };
    const ctx = {
        TENANT: 'aaa',
        VENUE: 'bbb',
        BASE_URL: fakeURL,
    };
    const params = {
        baseURL: process.env.BASE_URL || '',
        tenant: ctx.TENANT,
        venue: ctx.VENUE,
        authDataProvider: authDataProvider,
        //refreshTokenHandler,
        onConnectedAsync: (accessToken) => __awaiter(void 0, void 0, void 0, function* () {
            console.log('ws connected!');
        }),
        onDisconnectAsync: () => __awaiter(void 0, void 0, void 0, function* () {
            console.log('ws disconnected');
            //webSocketConnected = false;
        }),
        onKDSMessageAsync: (message) => __awaiter(void 0, void 0, void 0, function* () {
            // we have new message
            console.log(`new or updated order [${message.id}]`);
        }),
        onOrdersUpdateAsync: (order) => __awaiter(void 0, void 0, void 0, function* () { }),
        onNotificationAsync: (message) => __awaiter(void 0, void 0, void 0, function* () {
            console.log(`NOTIFICATION: ${JSON.stringify(message)}`);
        }),
        onAuthFailure: () => __awaiter(void 0, void 0, void 0, function* () { }),
        enableKDS: true,
    };
    yield listener.connectWebSockets(params);
}));
const authDataProvider = (
// ctx: any,
// refreshTokenProvider,
// forceRefresh?: boolean,
) => __awaiter(void 0, void 0, void 0, function* () {
    return { token: 'aaa', UUID: 'user1' };
});
function initWSForTest(baseURL) {
    return __awaiter(this, void 0, void 0, function* () {
        // listener is responsible for receiving orders from Ordering Stack
    });
}
